/* 	$Id: first.c,v 1.4 1993/11/06 03:38:17 lusk Exp $	 */

#ifndef lint
static char vcid[] = "$Id: first.c,v 1.4 1993/11/06 03:38:17 lusk Exp $";
#endif /* lint */

/*@
     first - test program that sends one integer from one process to another,
             using isend, irecv, wait
@*/

#include "mpi.h"

worker( argc, argv )
int argc;
char **argv;
{
    int rank, data, to, from, tag, count, np;
    int src, dest;
    int st_source, st_tag, st_count;
    MPI_Comm_request handle;
    MPI_Status status;

    MPI_Init( &argc, argv );
    MPI_Comm_rank( MPI_COMM_WORLD, &rank );
    printf( "Process %d is alive\n", rank );

    src  = 1;
    dest = 0;

    if (rank == src)
    {
	to     = dest;
	count  = 1;		/* one int, that is */
	tag    = 2000;
	data   = 777;
	MPI_Isend( &data, count, MPI_INT, to, tag, MPI_COMM_WORLD, &handle );
	MPI_Wait( handle, &status );
	printf( "%d sent %d\n", rank, data );
    }
    else
    if (rank == dest) {
	tag   = 2000;
	count = 1;		/* one int */
	from  = MPI_ANY_SOURCE;
	MPI_Irecv(&data, count, MPI_INT, from, tag, MPI_COMM_WORLD, &handle ); 
	MPI_Wait( handle, &status );

	MPI_Get_source( status, st_source );
	MPI_Get_tag(    status, st_tag );
	MPI_Get_count(  status, st_count );

	printf( "Status info: source = %d, tag = %d, count = %d\n",
	        st_source, st_tag, st_count );
	printf( "%d received %d\n", rank, data );
    }
    MPI_Finalize();
    printf( "Process %d exiting\n", rank );
}
