/*
 *  $Id: u_red_scata.c,v 1.3 1993/11/12 12:30:51 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: u_red_scata.c,v 1.3 1993/11/12 12:30:51 doss Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_User_reduce_scattera - 

@*/
MPI_User_reduce_scattera ( sendbuf, recvbuf, recvcnts, datatype, op, comm )
void             *sendbuf;
void             *recvbuf;
int              *recvcnts;
MPI_Datatype      datatype;
void            (*op)();
MPI_Comm  comm;
{
  int rank, size, i, count=0, extent;
  int *displs;
  void *buffer;

  /* Check for invalid arguments */
  if ( (comm            == (MPI_Comm)0) ||
       (comm->comm_type == MPIR_INTER) ) 
    return (MPI_SUCCESS); 

  /* Determine the "count" of items to reduce and set the displacements*/
  MPI_Extent ( datatype, &extent );
  MPI_Comm_size (comm, &size);
  MPI_Comm_rank (comm, &rank);
  displs = (int *)MALLOC(size*sizeof(int));
  for (i=0;i<size;i++) {
    displs[i] = count;
    count += recvcnts[i];
  }
  buffer = (void *)MALLOC(extent*count);

  /* Reduce to 0, then scatter */
  MPI_User_reducea ( sendbuf, buffer, count, datatype, op, 0, comm );
  MPI_Scatterv ( buffer, displs, recvcnts, datatype, recvbuf, recvcnts[rank],
		 datatype, datatype, 0, comm );
  
  FREE(buffer); FREE(displs);
  return (MPI_SUCCESS);
}
