/*
 *  $Id: attr_delval.c,v 1.6 1993/11/12 12:31:42 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

#ifndef MPIR_TRUE
#define MPIR_TRUE  1
#define MPIR_FALSE 0
#endif

/*@

MPI_Delete_attr - deletes attribute value associated with a key

@*/
int MPI_Delete_attr ( comm, keyval )
MPI_Comm comm;
int keyval;
{
  MPIR_HBT_node *attr;
  MPIR_Attr_key *attr_key = (MPIR_Attr_key *)keyval;
  int            status   = MPI_SUCCESS;

  if ( (comm != (MPI_Comm)0) && (keyval != 0) ) {
    if ( attr_key->delete_fn != (int(*)())0 ) 
      status = attr_key->delete_fn( comm, keyval, attr_key->extra_state );
    MPIR_HBT_delete(comm->attr_cache, keyval, &attr);
    if ( attr != (MPIR_HBT_node *)0 ) 
      (void) MPIR_HBT_free_node ( attr );
  }
  return(status);
}
